$(document).ready(function() {
    $(".configStep").addClass("d-none");
    inicialitza();        
    if ('serviceWorker' in navigator) {
        navigator.serviceWorker.register('./service-worker.js', {scope: './'})
        .then((reg) => {
          console.log('Registration succeeded. Scope is ' + reg.scope);
        }).catch((error) => {
          console.log('Registration failed with ' + error);
        });
    }
  });
    
  var semestresEscrits={1:"Febrer-juny",2:"Setembre-febrer"};
  var pluralTipusEscrits={'obligatoria':"Obligatòries",'optativa':"Optatives",'basica':"Bàsiques"};
  var singularTipusEscrits={'obligatoria':"Obligatòria",'optativa':"Optativa",'basica':"Bàsica"};
  var accionsEscrites={"suspesa":"<span class='text-danger'>Suspesa</span>","convalidada":"<span class='text-primary'>Convalidada</span>","superada":"<span class='text-success'>Superada</span>","proposada":"<span class='text-info'>Proposada</span>","matriculada":"<span class=''>Matriculada per l'usuari</span>"}
  var jsonFile;  
  var endStep=0;  
  var assignaturesPerCodi=[];  
  var assignaturesPerTipus=[];
  var assignaturesSegonsItinerari=[];
  var codiAssignaturesSegonsItinerari=[];
  var horesSetmanalsPerAssignatura=10;
  var nomUsuari="";
  var estudis="";
  var estatsAssig=0; // per assignar estats a assignatures al pas de configurar-les
  var proposta=[]; // On desarem la proposta / les propostes
  var propostaNova=[]; // Clonem proposta i ho netegem al final.
  var assignaturesColocades=[]; // Matriu per desar els codis d'assignatures que posem a proposta[] (i a les subpropostes)
  var assignaturesColocadesPerSemestre=[]; // Matriu per desar els codis d'assignatures que posem a proposta[] (i a les subpropostes, per semestre, així validem despresDe!)
  var creditsFets=[]; // Sumatori de crèdits totals col·locats
  var creditsFetsPerTipus=[]; // Matriu de sumatoris: crèdits ja col·locats per tipus d'assignatura (optativa, ob, bàsica...)
  var creditsFetsPerItinerari=[]; // Matriu de sumatoris: crèdits ja fets segons itinerari de l'assignatura, si s'escau
  var assignaturesPerItinerari=[]; // Matriu de sumatoris: assignatures ja fetes segons itinerari de l'assignatura, si s'escau
  var assignaturesItera=[]; // On duplicarem la matriu d'assignatures dels estudis seleccionats      
  var assignaturesOptativesNecessaries=[]; // Aquestes les hem de prioritzar a les que no a l'hora de matricular
  
  function showProposta(whichProposta="base") {      
    var credPerTipusAra=[];
    var credTotalAra=0;
    var copsAssig=[];
    var htmlFin="";      
    var numAra=0;

    jsonFile.itineraris.forEach(function(itinerari,idNum) {                
      if (itinerari==whichProposta) {
        numAra=idNum;
      }        
    });

    htmlFin+="<div id='paper"+numAra+"'></div>";

    htmlFin+="<table class='table'><thead><tr><th>Assignatura</th><th>Tipus</th><th>Crèdits</th><th>Observacions</th></tr></thead><tbody>";
    var creditsSuperatsGraph=0;
    var creditsSuperatsGraphPerTipus=[];
    var assigPosadesASuperat=[];
    propostaNova[whichProposta].forEach(function(semestreArr,any) {
      //htmlFin+="<tr><td colspan=5><h3>"+any+" "+semestresEscrits[semestre]+"</h3></td></tr>";
      semestreArr.forEach(function(assignatures,semestre){
        var titolAra=any+" "+semestresEscrits[semestre];
        if (any==0 && semestre==0) {
          titolAra="Assignatures ja superades o convalidades";
        } 
        htmlFin+="<tr><td class='table-info' colspan=4><h5>"+titolAra+"</h5></td></tr>";
        assignatures.forEach(function(e) {
          var assigAra=assignaturesPerCodi[e.codiAssignatura];
          if (assigAra.itineraris.includes(whichProposta)) {
            tipusAra="obligatoria";
          }  else {
            tipusAra=assigAra.tipus;
          }
          htmlFin+="<tr>";
          htmlFin+="<td><strong>"+assigAra.codi+"</strong> "+assigAra.nom+"</td>";
          htmlFin+="<td>"+singularTipusEscrits[tipusAra]+"</td>";
          htmlFin+="<td class='text-end'>"+assigAra.credits+"</td>";
          var obsAra="";
          obsAra=accionsEscrites[e.accio];
          
          if (e.accio=="superada" || e.accio=="suspesa") { obsAra+=" ("+e.nota+")"; }
          htmlFin+="<td>"+obsAra+"</td>";
          htmlFin+="</tr>";
          //htmlFin+="<strong>"+assigAra.codi+" "+assigAra.nom+"</strong> "+e.accio+" ("+assigAra.credits+" crèdits - "+assigAra.tipus+" -"+tipusAra+"- després de "+assigAra.despresDe.join(", ")+" - Semestre "+assigAra.semestre+")<br />";
          credTotalAra+=assigAra.credits;
          if (!copsAssig[assigAra.codi]) { 
            copsAssig[assigAra.codi]=0; 
            if (!credPerTipusAra[tipusAra]) { credPerTipusAra[tipusAra]=0; }
            credPerTipusAra[tipusAra]+=assigAra.credits;            
          }          
          copsAssig[assigAra.codi]++;
          if (!assigPosadesASuperat[assigAra.codi]) {             
            if (e.accio=="superada"||e.accio=="convalidada") {
              assigPosadesASuperat[assigAra.codi]=1;
              creditsSuperatsGraph+=assigAra.credits;
              if (!creditsSuperatsGraphPerTipus[tipusAra]) { creditsSuperatsGraphPerTipus[tipusAra]=0; }
              creditsSuperatsGraphPerTipus[tipusAra]+=assigAra.credits;
            }
          }
        });
        //htmlFin+="<hr />";                    
      });
      //htmlFin+="<hr />";
    });
    htmlFin+="<tr><td class='table-info' colspan=4><h5>Crèdits propostats / necessaris</h5></td></tr>";
    htmlFin+="<tr><td></td><td><strong>Total</strong></td><td class='text-end'>"+credTotalAra+"/"+jsonFile.creditsTotals+"</td><td></td></tr>";
    for (var i in creditsFetsPerTipus[whichProposta]) { 
      htmlFin+="<tr><td></td><td><strong>"+pluralTipusEscrits[i]+"</strong><td class='text-end'>"+credPerTipusAra[i]+"/"+jsonFile.credits[i]+"</td><td></td></tr>";
    }

    htmlFin+="<tr><td class='table-info' colspan=4><h5>Percentatge d'assoliment</h5></td></tr>";
    var percentAssol=(creditsSuperatsGraph/credTotalAra)*100;
    htmlFin+="<tr><td></td><td><strong>Total</strong></td><td class='text-end'>"+creditsSuperatsGraph+"/"+credTotalAra+"</td><td><div class='progress'><div class='progress-bar' role='progressbar' style='width: "+percentAssol+"%;' aria-valuenow='"+percentAssol+"' aria-valuemin='0' aria-valuemax='100'>"+(Math.round((percentAssol + Number.EPSILON) * 100) / 100)+"%</div></div></td></tr>";
    for (var i in creditsFetsPerTipus[whichProposta]) { 
      if (isNaN(creditsSuperatsGraphPerTipus[i])) { creditsSuperatsGraphPerTipus[i]=0; }
      percentAssol=(creditsSuperatsGraphPerTipus[i]/credPerTipusAra[i])*100;


      htmlFin+="<tr><td></td><td><strong>"+pluralTipusEscrits[i]+"</strong><td class='text-end'>"+creditsSuperatsGraphPerTipus[i]+"/"+credPerTipusAra[i]+"</td><td><div class='progress'><div class='progress-bar' role='progressbar' style='width: "+percentAssol+"%;' aria-valuenow='"+percentAssol+"' aria-valuemin='0' aria-valuemax='100'>"+(Math.round((percentAssol + Number.EPSILON) * 100) / 100)+"%</div></div></td></tr>";
    }
    
    htmlFin+="</tbody></table>";
    return htmlFin;
  }

  function inicialitza() {
    $(".preloader").addClass("d-none");
    if (localStorage.length<3) {                    
      init=1;
    } else {
      init=0;
    }      
    if (init==0) {
      nomUsuari=localStorage.nomUsuari;
      $(".nomUsuariHolder").html(nomUsuari);
      $("#nomUsuari").val(nomUsuari);
      estudis=localStorage.estudis;
    }
    $.getJSON("JSON/config.json?"+Date.now(), function(json) { 
      for (let key in json) {
        if (key=="Graus") {
          for (let key2 in json[key]) {
            if (init==0 && json[key][key2]==estudis) {
              $(".estudisHolder").html(key2)
            }                
            $("#estudis").append("<option value='"+json[key][key2]+"'>"+key2+"</option>");
          }
        } else {
          // Convalidacions
          for (let key2 in json[key]) {
            $("#estudisPrevis").append("<option value='"+json[key][key2]+"'>"+key2+"</option>");
          }
        }          
      }          
      if (init==0) {
        $("#estudis").val(estudis);
        
        $.getJSON("JSON/"+estudis+"?"+Date.now(), function(json) {
          
          jsonFile=json;

          var dedicacio=localStorage.dedicacio;
          $("#dedicacio").val(dedicacio);
          $(".dedicacioHolder").html(dedicacio);
          
          $(".dadesUsuari").removeClass("d-none");

          var numAraIti=0;
          var itinerarisText=[];
            
          sortableItineraris(localStorage.itinerarisEscollits.split(","),1);
          llistaItinerarisOrdre(localStorage.itinerarisEscollits.split(","));
          creaSelectAssignatures();

          var assignaturesFetes=JSON.parse(localStorage.getItem("estatsAssignatura"));
          var estatsPerAssig=[];
          assignaturesFetes.forEach(function(e,i) {
            if (!estatsPerAssig[e.codiAssignatura]) { estatsPerAssig[e.codiAssignatura]=[]; }
            estatsPerAssig[e.codiAssignatura].push(e);                                    
          });
          for (const [codiAra, estatsAra] of Object.entries(estatsPerAssig)) {
            afegirAssig(codiAra,estatsAra);                  
          }
          $(".assigPreviesHolder").html($(".assignaturaFeta").length+" assignatures");
        });
      } else {
        $(".step1").removeClass("d-none");
      }       
    });  
  }
     
  function creaSelectAssignatures() {        
    jsonFile.assignatures.forEach(function (e,i) {        
      var assigAra=jsonFile.assignatures[i];                   
      var codiAra=assigAra.codi;
      var nomAra=assigAra.nom;
      var tipusAra=assigAra.tipus;
    
      assignaturesPerCodi[codiAra]=assigAra;
      if (!assignaturesPerTipus[tipusAra]) {assignaturesPerTipus[tipusAra]=[]; }
      assignaturesPerTipus[tipusAra].push(assigAra);
      for (var j in assigAra.itineraris) {
        var assigAraIti=assigAra.itineraris[j];
        if (!assignaturesSegonsItinerari[assigAraIti]) { assignaturesSegonsItinerari[assigAraIti]=[]; }
        assignaturesSegonsItinerari[assigAraIti].push(assigAra.codi);              
        if (!codiAssignaturesSegonsItinerari[assigAraIti]) { codiAssignaturesSegonsItinerari[assigAraIti]=[]; }
        codiAssignaturesSegonsItinerari[assigAraIti].push(assigAra.codi);              
      }          

      $("#assigPrevies").append("<option id='opt"+codiAra.replace(".","")+"' value='"+codiAra+"'>"+nomAra+"</option>");
    });
  }
  
  function sortableItineraris(itinerarisList,modVar=0) {        
    if (modVar==1) {
      var itinerarisListOk=[];
      itinerarisList.forEach(function(id) {
        var idNum=id.replace("item","");          
        itinerarisListOk[idNum]=jsonFile.itineraris[idNum];
      });
    } else {
      var itinerarisListOk=itinerarisList;
    }
    itinerarisListOk.forEach(function(nom,id) {
      $("#sortable").append("<li id='item"+id+"' class='ui-state-default'><i class='bi bi-arrow-down-up'></i> "+nom+"</li>");
    });
    $("#sortable").sortable();
  }

  function llistaItinerarisOrdre(itinerarisList) {
    var numAraIti=0;
    var itinerarisText=[];          
    itinerarisList.forEach(function(id) {
      var idNum=id.replace("item","");          
      numAraIti++;
      itinerarisText[numAraIti]=numAraIti+". "+jsonFile.itineraris[idNum];                        
    });
    $(".itinerarisHolder").html(itinerarisText.join(", "));
  }

  function seguentPas(pas) {        
    if (pas==1) {
      if ($("#nomUsuari").val().length>0) {
        localStorage.setItem("nomUsuari",$("#nomUsuari").val());      
        $("#nomUsuari").val($("#nomUsuari").val().replaceAll("<","&lt;").replaceAll(">","&gt;"));
        $(".nomUsuariHolder").html($("#nomUsuari").val());
        $(".step1").addClass("d-none");
        if (endStep==1) {
          $(".dadesUsuari").removeClass("d-none");
        } else {           
          $(".step2").removeClass("d-none");
        }
      } else {
        alert('Cal que indiquis el teu nom per continuar!');
      }
    }
  
    if (pas==2) {
      var estudis=$("#estudis").val();
      $(".estudisHolder").html($("#estudis").find("option:selected").text());
      $.getJSON("JSON/"+estudis+"?"+Date.now(), function(json) {
        jsonFile=json;            
        sortableItineraris(json.itineraris);
        creaSelectAssignatures();           
        localStorage.setItem("estudis",estudis);
        $(".step2").addClass("d-none");            
        if (endStep==1) {
          $(".dadesUsuari").removeClass("d-none");
        } else {           
          $(".step3").removeClass("d-none");
        }
      }) .fail(function() {
        endStep=2;
        alert( "Has d'escollir uns estudis vàlids" );
      });
    }

    if (pas==3) {
      var numHores=parseFloat($("#dedicacio").val());
      if (numHores==0 || isNaN(numHores)) {
        alert("Cal que indiquis un número d'hores");
      } else {
        localStorage.setItem("dedicacio",numHores);
        $(".dedicacioHolder").html(numHores);
        $(".step3").addClass("d-none");            
        if (endStep==1) {
          $(".dadesUsuari").removeClass("d-none");
        } else {           
          $(".step4").removeClass("d-none");
        }
      }
    }
    
    if (pas==4) {
      var itinerarisEscollits=$("#sortable").sortable('toArray');
      localStorage.setItem("itinerarisEscollits",itinerarisEscollits);
      llistaItinerarisOrdre(itinerarisEscollits);          
      $(".step4").addClass("d-none");            
      if (endStep==1) {
        $(".dadesUsuari").removeClass("d-none");
      } else {           
        $(".step5").removeClass("d-none");
      }
    }
      
    if (pas==5) {          
      $(".step5").addClass("d-none");            
      if (endStep==1) {
        $(".dadesUsuari").removeClass("d-none");
      } else {           
        $(".step6").removeClass("d-none");
      }
    }
    
    if (pas==6) {
      $(".step5").addClass("d-none");            
      $(".step6").addClass("d-none");            
      var valorEstPrev=$("#estudisPrevis").val();
      if (valorEstPrev!="no" && valorEstPrev.length>0) {
        $.getJSON("JSON/"+valorEstPrev+"?"+Date.now(), function(json) { 
          for (let key in json) {
            objPosa=[{accio: "convalidada",codiAssignatura: json[key],nota: "",semestre: "-Semestre"}];
            afegirAssig(json[key],objPosa);
          }              
          if (endStep==1) {
            $(".dadesUsuari").removeClass("d-none");
          } else {           
            $(".step8").removeClass("d-none");
          }
        });              
      } else {
        if (endStep==1) {
          $(".dadesUsuari").removeClass("d-none");
        } else {           
          $(".step7").removeClass("d-none");
        }
      }
    }
    
    if (pas==7) {
      $(".step7").addClass("d-none");            
      if (endStep==1) {
        $(".dadesUsuari").removeClass("d-none");
      } else {           
        $(".step8").removeClass("d-none");
      }
    }
    
    if (pas==8) {
      
      var estatsAssignatura=[];
      var errorsLlista=0;
      $(".estatAssignatura").each(function() {
        var codiAssignatura=$(this).data("codiassignatura");
        var codiEstat=codiAssignatura.replace(".","")+$(this).data("estatsassig");        
        if ($("#comSupera"+codiEstat).val()=="Estat") {
          errorsLlista++;
        } else {
          var estatAra={"codiAssignatura": codiAssignatura,"accio":$("#comSupera"+codiEstat).val(),"nota":$("#NotaAssig"+codiEstat).val(),"semestre":$("#QuanSuperaAny"+codiEstat).val()+"-"+$("#QuanSuperaSemestre"+codiEstat).val()};              
          estatsAssignatura.push(estatAra);
        }
      });
      if (errorsLlista>0) {
        alert("Alguna assignatura no s'ha desat perquè no s'ha indicat si estava superada, suspesa o convalidada, o si es volia forçar a matricular en un semestre determinat");
      } else {
        $(".step7").addClass("d-none");            
        $(".step8").addClass("d-none");            
        $(".dadesUsuari").removeClass("d-none");          
      }
      localStorage.setItem("estatsAssignatura",JSON.stringify(estatsAssignatura));
      $(".assigPreviesHolder").html($(".assignaturaFeta").length+" assignatures");
    }        
  
  }
  
  function delAssigPrevia(id,skipConfirm=0) {                    
    if (skipConfirm==1 || confirm("Segur que vols esborrar aquesta assignatura?")) {
      $(".assignaturaFeta"+id).remove();
      $("#assigPrevies").find("#opt"+id).removeClass("d-none");
    }
  }

  function delEstatAssig(codi,estat) {          
    var numEstatsAssig=$(".assignaturaFeta"+codi).find(".estatAssignatura").length;
    var textAfe="";
    if (numEstatsAssig==1) {
      textAfe=" Com que només queda aquest estat, s'esborrarà també l'assignatura."
    }
    if (confirm("Segur que vols esborrar aquesta línia d'estat s'assignatura?"+textAfe)) {
      $(".estatAssignatura"+estat).remove();
      if (textAfe.length>0) {
        delAssigPrevia(codi,1);
      }
    }
  }
      
  function afegirAssig(codi,estats=[]) {          
    if (codi!="no") {
      if ($(".assignaturaFeta"+codi.replace(".","")).length==0) {
        var htmlAra="<div class='row assignaturaFeta assignaturaFeta"+codi.replace(".","")+"'>";
        htmlAra+="<div class='col-5'><strong>"+codi+"</strong> "+assignaturesPerCodi[codi].nom+"</div>";
        htmlAra+="<div class='col-6 conteEstatsAssignatura conteEstatsAssignatura"+codi.replace(".","")+"'></div>";
        htmlAra+="<div class='col-1 text-end'><button class='btn btn-outline-primary' type='button' onclick='javascript:afegirEstatAssig(\""+codi+"\");'><i class='bi-plus-circle'></i></button></div>";
        //htmlAra+="<div class='col-1 text-end'><button class='btn btn-outline-danger' type='button' onclick='javascript:delAssigPrevia(\""+codi.replace(".","")+"\");'><i class='bi-trash'></i></button></div>";
        htmlAra+="</div>";
        $(".assigContainer").append(htmlAra);
        $("#assigPrevies").find("#opt"+codi.replace(".","")).addClass("d-none");
        $("#assigPrevies").val("no");
      }
    }      
    if (Object.keys(estats).length==0) {
      afegirEstatAssig(codi);
    } else {            
      for (const [idObj, estatAra] of Object.entries(estats)) {
        afegirEstatAssig(codi,estatAra);
      }
    }
  }
     
  function afegirEstatAssig(codi,estat=[]) {
    var htmlAra="<div data-codiassignatura='"+codi+"' data-estatsassig='"+estatsAssig+"' class='mb-3 estatsAssignatura"+codi.replace(".","")+" estatAssignatura estatAssignatura"+estatsAssig+" row'>";
    htmlAra+="<div class='col-4'><select class='form-select selSupera"+estatsAssig+"' onchange='javascript:checkSiPosaNota(\""+estatsAssig+"\");' id='comSupera"+codi.replace(".","")+estatsAssig+"'><option>Estat</option><option value='superada'>Superada</option><option value='convalidada'>Convalidada</option><option value='suspesa'>Suspesa</option><option value='matriculada'>Matriculada</option></select></div>";
    htmlAra+="<div class='col-2'><input placeholder='Nota' step=0.1 type='number' min=0 max=10 class='d-none notaAssigEstat"+estatsAssig+" form-control notaEstat"+estatsAssig+"' id='NotaAssig"+codi.replace(".","")+estatsAssig+"' /></div>";
    htmlAra+="<div class='col-5'><div class='input-group'><input placeholder='Any' step=1 type='number' min=2000 max=2030 class='form-control' id='QuanSuperaAny"+codi.replace(".","")+estatsAssig+"' /><select class='form-select' id='QuanSuperaSemestre"+codi.replace(".","")+estatsAssig+"'><option>Semestre</option>";
    for (var i in semestresEscrits) {
      htmlAra+="<option value='"+i+"'>"+semestresEscrits[i]+"</option>";
    }       
    htmlAra+="</select></div></div>";
    htmlAra+="<div class='col-1 text-end'><button class='btn btn-outline-secondary' type='button' onclick='javascript:delEstatAssig(\""+codi.replace(".","")+"\",\""+estatsAssig+"\");'><i class='bi-trash'></i></button></div>";
    htmlAra+="</div>";

    $(".conteEstatsAssignatura"+codi.replace(".","")).append(htmlAra);

    if (Object.keys(estat).length>0) {
      $("#comSupera"+codi.replace(".","")+estatsAssig).val(estat.accio);
      if (!estat.nota) {estat.nota=""; }
      $("#NotaAssig"+codi.replace(".","")+estatsAssig).val(estat.nota);
      var partsSem=estat.semestre.split("-");
      $("#QuanSuperaAny"+codi.replace(".","")+estatsAssig).val(partsSem[0]);
      $("#QuanSuperaSemestre"+codi.replace(".","")+estatsAssig).val(partsSem[1]);
    }

    checkSiPosaNota(estatsAssig);
    
    estatsAssig++;
  }

  function checkSiPosaNota(codiEstat) {
    if ($(".selSupera"+codiEstat).val()=="convalidada" || $(".selSupera"+codiEstat).val()=="matriculada") {
      $(".notaAssigEstat"+codiEstat).addClass("d-none");
      $(".notaEstat"+codiEstat).val("");
    } else {
      $(".notaAssigEstat"+codiEstat).removeClass("d-none");
    }          
  }

  function togglePreloader() {
    if ($(".preloader").hasClass("d-none")) {
      $("#mainContent").addClass("d-none");
      $(".preloader").removeClass("d-none");
    } else {
      $("#mainContent").removeClass("d-none");
      $(".preloader").addClass("d-none");
    }
  }
    
  function calculaProposta() {
      creaEstructuraProposta();
      propostaNova=[];       

      togglePreloader();
      
      
      var dedicacio=localStorage.dedicacio; // Hores setmanals totals
      var creditsQuePotFer=Math.round(dedicacio/horesSetmanalsPerAssignatura);

      var htmlPosa="";                  
      htmlPosa+="<h3>Calculant proposta...</h3>";
      htmlPosa+="<p>La majoria d'assignatures tenen 6 crèdits excepte algun cas especial que en té 12, com el TFG o les pràctiques. Cada 6 crèdits requereixen aproximadament "+horesSetmanalsPerAssignatura+" hores setmanals dedicació. La teva dedicació setmanal de "+dedicacio+" hores ";
      var horesPerTot=creditsQuePotFer*horesSetmanalsPerAssignatura;        
      if (creditsQuePotFer==0) {
        htmlPosa+=" és massa baixa per a generar una recomanació de matrícula realista. Et recomanem que augmentis la dedicació com a mínim a 10 hores.<br /><br />";
        htmlPosa+="<button type='button' class='btn btn-primary' onclick='javascript:canviaDedicacio("+horesSetmanalsPerAssignatura+");'>Augmentar dedicació a "+horesSetmanalsPerAssignatura+" hores setmanals</button>";
      } else if (horesPerTot>dedicacio) {          
        htmlPosa+=" et permet fer "+(creditsQuePotFer*6)+" crèdits (unes "+creditsQuePotFer+" assignatures) si augmentes la dedicació fins a les "+horesPerTot+" hores ";
        if (creditsQuePotFer>1) {
          htmlPosa+=" o, si vols fer menys crèdits ("+((creditsQuePotFer-1)*6)+", que equivalen a unes "+(creditsQuePotFer-1)+" assignatures) pots reduïr les hores a "+((creditsQuePotFer-1)*horesSetmanalsPerAssignatura)+" setmanals. Vols modificar la dedicació?<br /><br />";
          htmlPosa+="<button type='button' class='btn btn-primary' onclick='javascript:canviaDedicacio("+horesPerTot+");'>Augmentar dedicació a "+horesPerTot+" hores setmanals</button>";
          htmlPosa+="<button type='button' class='btn btn-primary' onclick='javascript:canviaDedicacio("+((creditsQuePotFer-1)*horesSetmanalsPerAssignatura)+");'>Reduïr dedicació a "+((creditsQuePotFer-1)*horesSetmanalsPerAssignatura)+" hores setmanals</button>&nbsp;&nbsp;";
        } else {
          htmlPosa+=" que és el mínim de dedicació recomanada. Vols augmentar la dedicació i tornar-ho a intentar?<br /><br />";
          htmlPosa+="<button type='button' class='btn btn-primary' onclick='javascript:canviaDedicacio("+horesPerTot+");'>Si, augmentar la dedicació fins a les "+horesPerTot+" hores setmanals</button>";
        }
        
       } else if (horesPerTot<dedicacio) {          
        htmlPosa+=" et permet fer "+((creditsQuePotFer+1)*6)+" crèdits (unes "+(creditsQuePotFer+1)+" assignatures) si augmentes la dedicació fins a les "+((creditsQuePotFer+1)*horesSetmanalsPerAssignatura)+" hores ";
        if (creditsQuePotFer>0) {
          htmlPosa+=" o, si vols fer menys crèdits: "+(creditsQuePotFer*6)+" que equivalen a unes "+(creditsQuePotFer)+" assignatures) pots reduïr les hores a "+(horesPerTot)+" setmanals. Vols modificar la dedicació?<br /><br />";
          htmlPosa+="<button type='button' class='btn btn-primary' onclick='javascript:canviaDedicacio("+((creditsQuePotFer+1)*horesSetmanalsPerAssignatura)+");'>Augmentar dedicació a "+((creditsQuePotFer+1)*horesSetmanalsPerAssignatura)+" hores setmanals</button>&nbsp;&nbsp;";
          htmlPosa+="<button type='button' class='btn btn-primary' onclick='javascript:canviaDedicacio("+horesPerTot+");'>Reduïr dedicació a "+horesPerTot+" hores setmanals</button>";

        } else {
          htmlPosa+=" que és el mínim de dedicació recomanada. Vols augmentar la dedicació i tornar-ho a intentar?<br /><br />";
          htmlPosa+="<button type='button' class='btn btn-primary' onclick='javascript:canviaDedicacio("+horesSetmanalsPerAssignatura+");'>Si, augmentar dedicació a "+horesSetmanalsPerAssignatura+" hores setmanals</button>";
        }
        
      } else {
        //htmlPosa+=" pots matricular-te de "+creditsQuePotFer+" assignatures al semestre.";
        htmlPosa=calculaProposta2();
      }
      
      togglePreloader();
      
      $(".calculProposta").removeClass("d-none").html("<div class='proposta_part1'>"+htmlPosa+"</div>");

      //graphPropostes();


      $('button[data-bs-toggle="tab"]').on('shown.bs.tab', function (e) {
        graphPropostes($(e.target).data("quinaproposta"));
      })


      graphPropostes($(".tab-pane:visible").data("quinaproposta"));
      
    }

    


    function creaEstructuraProposta(nom="base") {      
      if (nom=="base") {          
        proposta[nom]=[];        
        assignaturesColocades[nom]=[];
        assignaturesColocadesPerSemestre[nom]=[];
        creditsFets[nom]=0;
        creditsFetsPerTipus[nom]=[];
        creditsFetsPerItinerari[nom]=[];
        assignaturesPerItinerari[nom]=[];
        assignaturesItera[nom]=[];
        for (var i in jsonFile.itineraris) {
          proposta[jsonFile.itineraris[i]]=[];
          assignaturesColocades[jsonFile.itineraris[i]]=[];
          assignaturesColocadesPerSemestre[jsonFile.itineraris[i]]=[];
          creditsFets[jsonFile.itineraris[i]]=0;
          creditsFetsPerTipus[jsonFile.itineraris[i]]=[];
          creditsFetsPerItinerari[jsonFile.itineraris[i]]=[];
          assignaturesPerItinerari[jsonFile.itineraris[i]]=[];
          assignaturesItera[jsonFile.itineraris[i]]=[];
        }
      }
      if (nom!="base") {           
        proposta[nom]=cloneObject(proposta['base']);
        assignaturesColocades[nom]=cloneObject(assignaturesColocades['base']);
        assignaturesColocadesPerSemestre[nom]=cloneObject(assignaturesColocadesPerSemestre['base']);
        creditsFets[nom]=creditsFets['base'];
        creditsFetsPerItinerari[nom]=cloneObject(creditsFetsPerItinerari['base']);
        assignaturesPerItinerari[nom]=cloneObject(assignaturesPerItinerari['base']);
        assignaturesItera[nom]=cloneObject(assignaturesItera['base']);

        assignaturesItera[nom].forEach(function(e,i) {
          if (e.tipus=="optativa" && e.itineraris.includes(nom)) {
            assignaturesItera[nom][i]["tipus"]="obligatoria";
            if (e.despresDe.length>0) {                
              if (!assignaturesOptativesNecessaries[nom]) { assignaturesOptativesNecessaries[nom]=[]; }
              for (var idd in e.despresDe) {                  
                if (!assignaturesOptativesNecessaries[nom].includes(e.despresDe[idd])) {
                  assignaturesOptativesNecessaries[nom].push(e.despresDe[idd]);
                }
              }
              
            }
          }
        });
      }
    }

    function calculaProposta2() {
      
      var htmlAra=""
      var semestreActual=calculaSemestreActual();
      
      // proposta['base'][any][semestre]={assignatures}        
      // podríem arribar a demanar quan es vol començar la proposta (any/semestre)
      // Omplir proposta amb convalidades a [0000], i posar la resta
      // Després iterar entre les que quedin
      // Mantenir sumatori de crèdits superats
      // Mantenir sumatori de crèdits d'itinerari superats (per itinerari)

      // 0. Inicialitzacions        
      assignaturesItera['base']=jsonFile.assignatures.slice(); // Duplicat de la matriu d'assignatures dels estudis
      assignaturesItera['base'].sort(ordenaItera);
      var estatsAssignatura=JSON.parse(localStorage.getItem("estatsAssignatura")); // Variable amb els estats d'assignatures configurades per l'usuari (fetes, convalidades i forçades)        
      
      // 1. Busquem les assignatures que ja estan 
      estatsAssignatura.forEach(function(elementAra) {      
        //console.log(elementAra);
        if (elementAra.accio!="suspesa") {
          var semestreAraParts=elementAra.semestre.split("-");
          if (semestreAraParts[1]=="Semestre") { semestreAraParts[1]=0; }
          if (semestreAraParts[0].length==0) { semestreAraParts[0]=0; }
          if (!proposta['base'][semestreAraParts[0]]) {proposta['base'][semestreAraParts[0]]=[]; }
          if (!proposta['base'][semestreAraParts[0]][semestreAraParts[1]]) {proposta['base'][semestreAraParts[0]][semestreAraParts[1]]=[]; }
          proposta['base'][semestreAraParts[0]][semestreAraParts[1]].push(elementAra);                    

          assignaturesColocades['base'].push(elementAra.codiAssignatura);
          if (!assignaturesColocadesPerSemestre['base'][semestreAraParts[0]+"-"+semestreAraParts[1]]) { assignaturesColocadesPerSemestre['base'][semestreAraParts[0]+"-"+semestreAraParts[1]]=[]; }
          assignaturesColocadesPerSemestre['base'][semestreAraParts[0]+"-"+semestreAraParts[1]].push(elementAra.codiAssignatura);
          for (var i in jsonFile.itineraris) {
            assignaturesColocades[jsonFile.itineraris[i]].push(elementAra.codiAssignatura);
            if (!assignaturesColocadesPerSemestre[jsonFile.itineraris[i]][semestreAraParts[0]+"-"+semestreAraParts[1]]) { assignaturesColocadesPerSemestre[jsonFile.itineraris[i]][semestreAraParts[0]+"-"+semestreAraParts[1]]=[]; }
            assignaturesColocadesPerSemestre[jsonFile.itineraris[i]][semestreAraParts[0]+"-"+semestreAraParts[1]].push(elementAra.codiAssignatura);
          }
          for (var i in proposta) {
            actualitzaPropostaiSumatoris(i);
          }
        }

      });
        
      // Comencem a crear una proposta per a cada itinerari
      localStorage.itinerarisEscollits.split(",").forEach(function(e,i) {          
        var idNum=e.replace("item",""); 
        creaEstructuraProposta(jsonFile.itineraris[idNum]);
        var iAra=0;
          while (iAra<2) {
            var iteracionsAqui=20;
            while (iteracionsAqui>0) {
              var colocaOrdre=["basica","obligatoria","optativa"];        
              colocaOrdre.forEach(function(quina) {
                var quantesEnQueden=assignaturesPerTipus[quina];
                var pararEnProves=2;
                while (quantesEnQueden>0 || pararEnProves>0) {
                  assignaturesPerTipus[quina].forEach(function(e,i) {
                    if (quina!="optativa" || codiAssignaturesSegonsItinerari[jsonFile.itineraris[idNum]].includes(e.codi)  || assignaturesOptativesNecessaries[jsonFile.itineraris[idNum]].includes(e.codi)) {
                      if (!assignaturesColocades[jsonFile.itineraris[idNum]].includes(e.codi)) {                                  
                        if (colocaAssignatura(e,jsonFile.itineraris[idNum])) {
                          quantesEnQueden--;                                                                
                          actualitzaPropostaiSumatoris(jsonFile.itineraris[idNum]);
                        }                  
                      }
                    }
                  });                        
                  pararEnProves--;                     
                }          
              });
              actualitzaPropostaiSumatoris(jsonFile.itineraris[idNum]);
              iteracionsAqui--;
            }

           // Ara intentem col·locar-hi la resta d'optatives que no són d'itinerari
          var quedenAltres=0;
          var quedenAltresCred=0;
          assignaturesItera[jsonFile.itineraris[idNum]].forEach(function(e,i) {
            if (e.tipus=="obligatoria" || e.tipus=="basica") {
              quedenAltres++;
              quedenAltresCred+=e.credits;
            }
          });

          var quantesEnQueden=assignaturesPerTipus["optativa"].length-codiAssignaturesSegonsItinerari[jsonFile.itineraris[idNum]].length;                
          while (quantesEnQueden>0) {
            assignaturesPerTipus["optativa"].forEach(function(e,i) {                                       
                if (!assignaturesColocades[jsonFile.itineraris[idNum]].includes(e.codi)) {                        
                    if (colocaAssignatura(e,jsonFile.itineraris[idNum])) {
                      quantesEnQueden--;                                          
                      actualitzaPropostaiSumatoris(jsonFile.itineraris[idNum]);
                    } 
                } else {
                  quantesEnQueden--;                                          
                }
            });                        
          }   
          iAra++;
        }

        // Retallem per darrere
        var credTotalAra=0;   
                  
        proposta[jsonFile.itineraris[idNum]].forEach(function(semestreArr,any) {
          semestreArr.forEach(function(assignatures,semestre){                
            assignatures.forEach(function(e,iAssig) {                  
              var assigAra=assignaturesPerCodi[e.codiAssignatura];
              if (assigAra.itineraris.includes(jsonFile.itineraris[idNum])) {
                tipusAra="obligatoria";
              }  else {
                tipusAra=assigAra.tipus;
              }
              credTotalAra+=assigAra.credits;
              if (tipusAra!="optativa" || credTotalAra<=jsonFile.creditsTotals) {
                if (!propostaNova[jsonFile.itineraris[idNum]]) { propostaNova[jsonFile.itineraris[idNum]]=[]; }
                if (!propostaNova[jsonFile.itineraris[idNum]][any]) { propostaNova[jsonFile.itineraris[idNum]][any]=[]; }
                if (!propostaNova[jsonFile.itineraris[idNum]][any][semestre]) { propostaNova[jsonFile.itineraris[idNum]][any][semestre]=[]; }
                propostaNova[jsonFile.itineraris[idNum]][any][semestre].push(e);
              }
            });
          });
        });         
      });        
  
      htmlAra+="<nav><div class='nav nav-tabs' id='nav-tab' role='tablist'>";
      var comptaI=0;
      var classAct="";
      var classAct2="";
      for (var i in propostaNova) {          
        comptaI++;
        if (comptaI==1) {
          classAct="active";
          classAct2="true";
        } else { classAct=""; classAct2="false"; }
        htmlAra+="<button class='nav-link "+classAct+"' id='nav-"+comptaI+"-tab' data-bs-toggle='tab' data-quinaproposta=\""+i+"\" data-bs-target='#nav-"+comptaI+"' type='button' role='tab' aria-controls='nav-"+comptaI+"' aria-selected='"+classAct2+"'>"+i+"</button>";
      }
      htmlAra+="</div></nav><div class='tab-content border-start border-end border-bottom p-3' id='nav-tabContent'>";
      comptaI=0;
      for (var i in propostaNova) {          
        comptaI++;
        if (comptaI==1) {
          classAct="show active";
        } else { classAct=""; }
        htmlAra+="<div class='tab-pane fade "+classAct+"' id='nav-"+comptaI+"' data-quinaproposta=\""+i+"\" role='tabpanel' aria-labelledby='nav-"+comptaI+"-tab'>";
        htmlAra+="<div class='alert alert-warning mb-3 mt-3'>Recorda que aquesta és una proposta orientativa generada automàticament. Abans de formalitzar la teva matrícula, comprova sempre les dependències de les assignatures escollides, i recorda que en tot moment pots actualitzar les teves preferències per forçar canvis a la proposta des de la configuració d'assignatures al bloc superior.</div>";
        htmlAra+=showProposta(i);
        htmlAra+="</div>";
      }
      htmlAra+="</div>";

      return htmlAra;
       
    }

    function miraSiPreviesFetes(assignatura,any,semestre,whichProposta='base') {
      var retVal=true;
      if (assignatura.despresDe.length>0) {
        assignatura.despresDe.forEach(function(e) {
          // "05.591//si Itinerari=Enginyeria de Computadors"
          if (typeof e =="number") {
            if (creditsFets[whichProposta]<e) {
              retVal=false;
            }
          } else {
            if (e=="Itinerari") {
              if (assignaturesPerItinerari[whichProposta][whichProposta]<assignaturesSegonsItinerari[whichProposta].length) {
                retVal=false;
              }                
            } else if (e.indexOf("//")>-1) {
              //mirar condició
            } else {
              if (!assignaturesColocades[whichProposta].includes(e) || (assignaturesColocadesPerSemestre[whichProposta][any+"-"+semestre] && assignaturesColocadesPerSemestre[whichProposta][any+"-"+semestre].includes(e))) {
                retVal=false;
              } 
            }              
          }
        });
      }
      return retVal;
    }

    function miraProperSemestreLliureProposta(assignatura,semestre="",whichProposta='base',ignoraMax=0) {
      var lastAny=0;
      var lastSem=0;
      var numCredits=assignatura.credits;
      var creditsPerFer=(localStorage.dedicacio/horesSetmanalsPerAssignatura)*6;

      if (semestre=="") {
        proposta[whichProposta].forEach(function(e,i) {
          e.forEach(function(e2,i2)  {
            var creditsFetsCompta=0;
            e2.forEach(function(e3,i3) {                
              creditsFetsCompta+=assignaturesPerCodi[e3.codiAssignatura].credits;                          
            });

            var creditsAOmplir=creditsPerFer-creditsFetsCompta;
            if (i>0) {
              if (lastAny==0 && creditsAOmplir>assignatura.credits) {                  
                lastAny=i;
                lastSem=i2;
              } 
            }
          });
        });
        if (lastSem==0 && lastAny==0) {
          var semAraParts=calculaSemestreActual();
          lastSem=semAraParts['semestre'];
          lastAny=semAraParts['any'];
        }
      } else {
        var partsSemestre=semestre.split("-");
        lastAny=partsSemestre[0];
        lastSem=partsSemestre[1];
      }                
      
      var creditsMax=0;
      if (proposta[whichProposta][lastAny] && proposta[whichProposta][lastAny][lastSem]) {
        proposta[whichProposta][lastAny][lastSem].forEach(function(e,i) {
          creditsMax+=assignaturesPerCodi[e.codiAssignatura].credits;          
        });        
      }        
      // Ja tenim nº de crèdits del semestre més enllà i nº d'assignatures
      var creditsAOmplir=creditsPerFer-creditsMax;
      
      if (miraSiPreviesFetes(assignatura,lastAny,lastSem,whichProposta) && ((assignatura.semestre==0 || assignatura.semestre==lastSem) && (numCredits<=creditsAOmplir || (numCredits>creditsPerFer &&ignoraMax==1)))) {                    
        return {"semestre": lastSem, "any": lastAny };
      } else {   
        if (!miraSiPreviesFetes(assignatura,lastAny,lastSem,whichProposta)) { return false; }
        
        if (numCredits>creditsPerFer && creditsMax==0 && (assignatura.semestre==0 || assignatura.semestre==lastSem)) {
          ignoraMax=1;
        } else {
          if (lastSem==1) {
            lastSem=2;
          } else {
            lastSem=1;
            lastAny++;
          }
        }          
        return miraProperSemestreLliureProposta(assignatura,lastAny+"-"+lastSem,whichProposta,ignoraMax);
        

      }


    }
    function colocaAssignatura(e,whichProposta="base") {
      // Mirem a proposta quin semestre hi ha lliure
      if (!assignaturesColocades[whichProposta].includes(e.codi)) {                                  
        var retVal=false;
        var maxTries=2000;
        var semAra="";        
        while (retVal==false && maxTries>0) {            
            retVal=miraProperSemestreLliureProposta(e,semAra,whichProposta);
            // Trobar actual i sumar 1
            if (semAra=="") {
              var semAraParts=calculaSemestreActual();
              semAra=semAraParts['any']+"-"+semAraParts['semestre'];              
            } else {
              var semAraParts=semAra.split("-");
              if (semAraParts[1]==1) {
                semAra=semAraParts[0]+"-2";              
              } else {
                semAra=parseInt(semAraParts[0])+1+"-1";              
              }
            }
            maxTries--;            
        }
        if (retVal) {
          var elementAra={"codiAssignatura":e.codi,"accio":"proposada","nota":"","semestre":retVal['any']+"-"+retVal['semestre'] };
          if (!proposta[whichProposta][retVal['any']]) {proposta[whichProposta][retVal['any']]=[]; }
          if (!proposta[whichProposta][retVal['any']][retVal['semestre']]) {proposta[whichProposta][retVal['any']][retVal['semestre']]=[]; }

          proposta[whichProposta][retVal['any']][retVal['semestre']].push(elementAra);
          assignaturesColocades[whichProposta].push(elementAra.codiAssignatura);
          if (!assignaturesColocadesPerSemestre[whichProposta][retVal['any']+"-"+retVal['semestre']]) { assignaturesColocadesPerSemestre[whichProposta][retVal['any']+"-"+retVal['semestre']]=[]; }
          assignaturesColocadesPerSemestre[whichProposta][retVal['any']+"-"+retVal['semestre']].push(elementAra.codiAssignatura);
          actualitzaPropostaiSumatoris(whichProposta);
        }
      }
    }


   


    function actualitzaPropostaiSumatoris(whichProposta="base") {
      var initVal=assignaturesItera[whichProposta].length;
      assignaturesItera[whichProposta].forEach(function(elementAra,index) {
        if (assignaturesColocades[whichProposta].includes(elementAra.codi)) {            

          // Sumem els crèdits per tipus
          // Si Proposta!=base hem de mirar si és optativa d'itinerari i marcar-la com a obligatòria
          if (whichProposta!="base") {
            if (codiAssignaturesSegonsItinerari[whichProposta] && codiAssignaturesSegonsItinerari[whichProposta].includes(elementAra.codi)) {
              elementAra.tipus="obligatoria";
            }
          }

          if (!creditsFetsPerTipus[whichProposta][elementAra.tipus]) {creditsFetsPerTipus[whichProposta][elementAra.tipus]=0; }          
          creditsFetsPerTipus[whichProposta][elementAra.tipus]+=elementAra.credits;
          // Sumem els crèdits totals
          creditsFets[whichProposta]+=elementAra.credits;            
          
          var itinerarisAra=elementAra.itineraris;
          itinerarisAra.forEach(function(itiAra) { 
            // Sumem els crèdits per itinerari            
            if (!creditsFetsPerItinerari[whichProposta][itiAra]) {creditsFetsPerItinerari[whichProposta][itiAra]=0; }
            creditsFetsPerItinerari[whichProposta][itiAra]+=elementAra.credits;
            // Sumem una assignatura a assignatures per itinerari
            if (!assignaturesPerItinerari[whichProposta][itiAra]) {assignaturesPerItinerari[whichProposta][itiAra]=0; }
            assignaturesPerItinerari[whichProposta][itiAra]++;
          });
          assignaturesItera[whichProposta].splice(index,1);
        }
      });
      if (initVal!=assignaturesItera[whichProposta].length) { actualitzaPropostaiSumatoris(); }

    }

  function editaConfig(pas) {
    endStep=1;
    $(".dadesUsuari").addClass("d-none");
    $(".step"+pas).removeClass("d-none");
  }
  
  function netejaLocalStorage() {
    if (confirm("Segur que vols eliminar les dades d'usuari desades? Aquesta acció no es pot desfer")) {          
      localStorage.clear();
      self.location.reload();
    }
  }

    function canviaDedicacio(numHores) {
      $("#dedicacio").val(numHores);
      endStep=1;
      seguentPas(3);
      calculaProposta();
    }

    function calculaSemestreActual() {
      // Retorna el semestre actual
      // Retorna Semestre i Any
      // Semestre 1 entre febrer i agost, la resta comptem semestre 2.
      var dateObj=new Date();
      var any=dateObj.getFullYear();
      var mes=dateObj.getMonth()+1;
      var semestre=1;
      if (mes>8 || mes==1) {
        if (mes==1) {
          any--;
        }
        semestre=2;
      } 
      return {"semestre":semestre, "any":any};
    }
          
  function cloneObject(obj) {
      var clone = [];
      for(var i in obj) {
          if(typeof(obj[i])=="object" && obj[i] != null)
              clone[i] = cloneObject(obj[i]);
          else
              clone[i] = obj[i];
      }
      return clone;
  }
    
function ordenaItera(a,b) {
    if (a['codi'] === b['codi']) {
    return 0;
    }
    else {
        return (a['codi'] < b['codi']) ? -1 : 1;
    }
}

 // Modificar org.Member, en creem un de nou assigantura.member amb un name2 i treient la imatge, retocant aliniacions, mides i comportaments.
 (this.joint = this.joint || {}),
 (this.joint.shapes = this.joint.shapes || {}),
 (function (e, t, r) {
     "use strict";
     var i = t.Element.define(
             "assignatura.Member",
             {
                 size: { width: 260, height: 100 },
                 attrs: {
                     rect: { width: 260, height: 100 },
                     ".card": { fill: "#FFFFFF", stroke: "#000000", "stroke-width": 2, "pointer-events": "visiblePainted", rx: 10, ry: 10 },
                     //image: { width: 48, height: 48, ref: ".card", "ref-x": 10, "ref-y": 5 },
                     ".rank": { ref: ".card", "ref-x": 15, "ref-y": 0.2, "font-family": "Courier New", "font-size": 12, "text-anchor": "start" },
                     ".name": { "font-weight": "600", ref: ".card", "ref-x":15, "ref-y": 0.4, "font-family": "Courier New", "font-size": 12, "text-anchor": "start" },
                     ".name2": { "font-weight": "700", ref: ".card", "ref-x":15, "ref-y": 0.6, "font-family": "Courier New", "font-size": 12, "text-anchor": "start" },
                     ".notacard": { "pointer-events": "visiblePainted", rx: 10, ry: 10, },
                     ".nota": { "font-weight": "500", ref: ".card", "ref-x":15, "ref-y": 0.8, "font-family": "Courier New", "font-size": 12, "text-anchor": "start" },
                 },
             },
             //{ markup: '<g class="rotatable"><g class="scalable"><rect class="card"/><image/></g><text class="rank"/><text class="name"/><text class="name2"/></g>' }
             { markup: '<g class="rotatable"><g class="scalable"><rect class="card"/><rect class="notacard"/></g><text class="rank"/><text class="name"/><text class="name2"/><text class="nota" /></g>' }
         ),
         s = r.Link.define("org.Arrow", { source: { selector: ".card" }, target: { selector: ".card" }, attrs: { ".connection": { stroke: "#585858", "stroke-width": 3 } }, z: -1 });
     (e.Arrow = s), (e.Member = i);
 })((this.joint.shapes.org = this.joint.shapes.org || {}), joint.dia, joint.dia);



function graphPropostes(quinaProposta) {
   var numAra=0;
   jsonFile.itineraris.forEach(function(itinerari,idProposta) {
     if (quinaProposta==itinerari) {
       numAra=idProposta;
     }
   });

   var colorsGraph=['#CCFF33','#FFFF99','#FFCCCC','#66CCFF','#FF3366','green','orange','lightblue','#FF33FE','#148F77','#ccc','yellow','blue','red','#CCFF33','#FFFF99','#FFCCCC','#66CCFF','#FF3366','green','orange','lightblue','#FF33FE','#148F77','#ccc','yellow','blue','red','#CCFF33','#FFFF99','#FFCCCC','#66CCFF','#FF3366','green','orange','lightblue','#FF33FE','#148F77','#ccc','yellow','blue','red']        
     var numSem=0;

     var assigsQuadres=[];
     var xara=0;
     var yara=70;
     var arrFutur=[];
     var linksFutur=[];

     // Primer fer un array -així podem calcular l'alçada necessària!

     propostaNova[quinaProposta].forEach(function(semestreArr,any) {
       semestreArr.forEach(function(assignatures,semestre){
         xara=40;
         assignatures.forEach(function(e) {             
           var assigAra=assignaturesPerCodi[e.codiAssignatura];                            
           var cadenaDividida=stringSplitter(assigAra.nom,30);                            
           var nom1=cadenaDividida[0];
           var nom2="";
           if (assigAra.nom.length>30) {                
             nom2=cadenaDividida[1];
           }
           var afefin="";
           if (assigAra.itineraris.includes(quinaProposta) && assigAra.tipus=="optativa") {
             afefin="Op. d'itinerari";
           } else {
             afefin=singularTipusEscrits[assigAra.tipus];
           }
           var links=[];
           if (assigAra.despresDe.length>0) {
             for (var i in assigAra.despresDe) {
               links.push(assigAra.despresDe[i]);
             }
           }
           arrFutur.push({"codiAssignatura":e.codiAssignatura,"xara":xara,"yara":yara,"codi":e.codiAssignatura+" ("+afefin+", "+assigAra.credits+" crèdits)", "nom1":nom1, "nom2":nom2,"fons":colorsGraph[numSem],"links":links,"accio": e.accio, "nota":e.nota});              
           xara+=280;
           if (xara>1000) {
             xara=40;
             yara+=130;
           }
         });
         numSem++;
         if (xara==40) { yara+=30; } else { yara+=160; }            
       });
     });


     var graph = new joint.dia.Graph();
     var paper = new joint.dia.Paper({
         el: $('#paper'+numAra),
         width: 1200,
         height: yara,
         gridSize: 1,
         model: graph,
         perpendicularLinks: true,
         restrictTranslate: true
     });

     var member = function(x, y, rank, name, name2, background, textColor="#000", accio="", nota="") {
         

         var cell = new joint.shapes.assignatura.Member({
             position: { x: x, y: y },
             attrs: {
                 '.card': { fill: background, stroke: 'none'},
                 //  image: { 'xlink:href': 'images/'+ image, opacity: 0.7 },
                 '.rank': { text: rank, fill: textColor, 'word-spacing': '-5px', 'letter-spacing': 0},
                 '.name': { text: name, fill: textColor, 'font-size': 13, 'font-family': 'Arial', 'letter-spacing': 0 },
                 '.name2': { text: name2, fill: textColor, 'font-size': 13, 'font-family': 'Arial', 'letter-spacing': 0 },
                 '.nota': {},
                 '.notacard': {},
             }
         });
         cell.attributes.attrs['.notacard']= { width: 0, height: 0, fill: "none", stroke: "none", "stroke-width": 0,  }            
         
          if (accio=="superada" && nota.length>0) {
            cell.attributes.attrs['.nota']= { text: nota, fill: '#fff', 'font-size': 15, "font-weight": 600, 'font-family': 'Arial', 'letter-spacing': 0, x:240,y:90 }
            cell.attributes.attrs['.notacard']= { width: 30, height: 30,fill: '#198754', stroke:'#198754', "stroke-width":2, x:230, y:70,"pointer-events": "visiblePainted", rx: 30, ry: 30, }            
          } else if (accio=="convalidada") {
            cell.attributes.attrs['.nota']= { text: "C", fill: '#fff', 'font-size': 15, "font-weight": 600, 'font-family': 'Arial', 'letter-spacing': 0, x:240,y:90 }
            cell.attributes.attrs['.notacard']= { width: 30, height: 30,fill: '#0d6efd', stroke:'#0d6efd', "stroke-width":2, x:230, y:70,"pointer-events": "visiblePainted", rx: 30, ry: 30, }
          } else if (accio=="suspesa" && nota.length>0) {
            cell.attributes.attrs['.nota']= { text: nota, fill: '#fff', 'font-size': 15, "font-weight": 600, 'font-family': 'Arial', 'letter-spacing': 0, x:240,y:90 }
            cell.attributes.attrs['.notacard']= { width: 30, height: 30,fill: '#dc3545', stroke:'#dc3545', "stroke-width":2, x:230, y:70 ,"pointer-events": "visiblePainted", rx: 30, ry: 30,}
          }
          
         graph.addCell(cell);
         return cell;
     };

     function link(source, target, breakpoints) {

         var link2 = new joint.shapes.standard.Link();
         link2.source(source);
         link2.target(target);
         link2.addTo(graph).toBack();
     }
     // Aquí iterem i hi afegim els membres a partir de l'array
     arrFutur.forEach(function(e,i) {
       assigsQuadres[e.codiAssignatura] = member(e.xara, e.yara, e.codi, e.nom1, e.nom2, e.fons, "#000", e.accio, e.nota);         
       //console.log(e.links);
     });
     // I ara que les tenim totes fetes, tornem a iterar per posar les relacions
     arrFutur.forEach(function(e,i) {
       for (var i in e.links) {       
         if (assigsQuadres[e.links[i]] && assigsQuadres[e.codiAssignatura]) {
           link(assigsQuadres[e.links[i]],assigsQuadres[e.codiAssignatura]);
         }
       }
     });
   
 
}
function stringSplitter(str, l){
 // From https://stackoverflow.com/questions/7624713/js-splitting-a-long-string-into-strings-with-char-limit-while-avoiding-splittin
 var strs = [];
 while(str.length > l){
     var pos = str.substring(0, l).lastIndexOf(' ');
     pos = pos <= 0 ? l : pos;
     strs.push(str.substring(0, pos));
     var i = str.indexOf(' ', pos)+1;
     if(i < pos || i > pos+l)
         i = pos;
     str = str.substring(i);
 }
 strs.push(str);
 return strs;
}